+++
title="Why Anarchists Shouldn't Have Phones"
date=2023-04-06

[taxonomies]
categories = ["Defensive"]
tags = ["mobile"]

[extra]
blogimage="/images/prison.jpg"
toc=true
dateedit=2023-05-10
a4="nophones-a4.pdf"
letter="nophones-letter.pdf"
+++

With effective [security culture and operational security](https://www.csrc.link/read/csrc-bulletin-1-en.html#header-a-base-to-stand-on-distinguishing-opsec-and-security-culture), the forces of repression wouldn't  know about our specific criminal activities, but they also wouldn't know about our lives, [relationships](https://www.csrc.link/threat-library/techniques/network-mapping.html), movement patterns, and so on. This knowledge is a huge advantage in narrowing down suspects and conducting targeted surveillance. Your phone's location is [tracked at all times](https://www.vice.com/en/article/m7vqkv/how-fbi-gets-phone-data-att-tmobile-verizon), and this data is harvested by private companies, allowing police to bypass laws requiring them to obtain a warrant. The phone's [hardware identifiers and subscription information](https://anonymousplanet.org/guide.html#your-imei-and-imsi-and-by-extension-your-phone-number) are logged by cell towers with every connection. Hacking services like [Pegasus](https://www.amnesty.org/en/latest/research/2021/07/forensic-methodology-report-how-to-catch-nso-groups-pegasus/) put total phone compromise within reach of even local law enforcement and are "zero-click," meaning success doesn't depend on you clicking a link or opening a file. 

<!-- more -->

On the flip side, after more than 30 recent arsons in a small town in France went unsolved, [investigators complained](https://actforfree.noblogs.org/post/2022/04/17/grenoblefrance-these-saboteurs-of-the-ultra-left-have-been-elusive-for-five-years/) that "it is impossible to exploit phone or vehicle registration data because they operate without phones or cars!" This article will outline some strategies for getting around any need you might have for a phone.

# Encryption and Geolocation

Some comrades respond to the issues with smartphones by using flip phones or a landline to communicate with each other, but this approach leaves nothing hidden from the eyes of the State because nothing is [encrypted](/glossary/#encryption) - neither the content of your conversations nor who is talking to whom. For example, in a [recent repressive operation](https://www.csrc.link/#quelques-premiers-elements-du-dossier-d-enquete-contre-ivan), the police set up real-time geolocation of the suspect's phone and made a list of everyone the suspect communicated with using unencrypted phone calls. A short biography was written for each contact.

It has become quite common for comrades to carry a cell phone around with them wherever they go, and in the contexts where people use flip phones, to make unencrypted calls to other anarchists. We shouldn't make the job of the police and intelligence agencies so easy; if the police don't have a phone to track, their only means of locating people is through physical surveillance around the clock, which is resource-intensive and can be detected. The first step in such a surveillance effort is to build a movement profile for the target, and the geolocation history of a cell phone provides this in comprehensive detail. Another primary goal of targeted surveillance is to map the target's social network in order to identify other targets. The only way to avoid giving this to our enemies on a silver platter is to use only encrypted tools to communicate with other anarchists; these tools can help prevent investigators from knowing who is talking to whom, or what they are talking about.  

# Metadata Patterns

The normalization of constant connectivity within dominant society has led some anarchists to correctly note that the [metadata](/glossary/#metadata) generated by phone activity is useful to investigators.  However, the conclusion that some draw from this insight, that we should ["never turn off the phone,"](https://www.csrc.link/#never-turn-off-the-phone-a-new-approach-to-security-culture) takes us in the wrong direction. Their logic is that if you step out of the normal metadata patterns, those moments become suspicious, and if those moments coincide with when an action occurs, that could be used as evidence to link you to the crime or to investigate you more closely. This is true, but the only conclusion that can be drawn from this - which is not a total dead end, at least - is to minimize the creation of normal metadata patterns in the first place.

Our connections to the infrastructures of domination must remain sporadic and unpredictable if we are to retain any semblance of freedom and ability to strike at the enemy. What if the reconnaissance required for an action requires an entire weekend away from electronic devices? Or let's start with the simple fact that phones must be left at home during an action - this only becomes the outlier to a pattern if phones otherwise accompany us wherever we go. In a normatively "always connected" life, either of these metadata changes would stick out like a sore thumb, but this is not the case if you refuse to always be plugged in.

# Do You Really Need a Phone? 

Whether you need a phone or not depends on whether you need *synchronous* communication every moment of your life. [*Synchronous*](/glossary/#synchronous-communication) means that two or more parties communicate in real time, as opposed to something [*asynchronous*](/glossary/#asynchronous-communication) like email, where messages are sent at different times. This "need" has become normalized, but it is worth resisting within the anarchist space. [Anarchy can only be anti-industrial](https://theanarchistlibrary.org/library/bismuto-beyond-the-moment#toc1), and this requires that we learn to live without the conveniences sold to us by the telecom companies: we should be able to live without being connected to the Internet at all times, without algorithmic real-time directions, and without the infinite flexibility that allows us to change plans at the last minute.

If you absolutely must use a phone, it should be as difficult as possible for an adversary to geotrack, intercept messages, or hack, which means using [GrapheneOS](/posts/grapheneos/). This is because using *only* [encrypted communications](/posts/e2ee/) to communicate with other anarchists rules out flip phones and landlines, and GrapheneOS is the only smartphone option that provides reasonable privacy and security. To prevent your movements from being tracked, you need to treat the smartphone like a landline and leave it at home when you are out of the house. Even if you use an anonymously purchased SIM card, if it is linked to your identity in the future, the service provider can be retroactively queried for any geolocation data. If you use the phone as we recommend, as a [Wi-Fi only device](/posts/grapheneos/#what-is-grapheneos), and keep it in airplane mode at all times, cell towers won't be able to connect to the phone. However, [malware](/glossary/#malware) could still turn the phone into an audio recording device or log GPS history. Also, it's not enough to only leave it at home when you're going to a demo or action, because that pattern of behavior will stand out as an outlier and serve as an indication that criminal activity is taking place in that window of time.  

However, it's best to not use a phone at all (for communication with other anarchists, at least). If only the comrades who are taking the biggest risks do this, they'll stand out. Identical in principle to black bloc tactics, the simple act of wearing a mask will provide cover for anyone to act anonymously. Therefore, we propose that those parts of the anarchist space that have been overtaken by dominant society's relationship to technology take several steps back to re-establish less intrusive baselines around phones. The strategies for living without phones that we will explain in the rest of this article rely on computers, where synchronous communication is possible but more limited because your computer is generally left at home.

## Bureaucracy 

Many bureaucratic organizations make it difficult not to have a phone: health care, the post office, banking, etc. Since these communications do not need to be encrypted, you can use a [Voice over Internet Protocol (VoIP)](/glossary#voip-voice-over-internet-protocol) application (which allows you to make phone calls over the Internet rather than through cell towers). 

Any VoIP application option on a computer is asynchronous because it doesn't ring when the computer is off - you rely on the voicemail feature to return missed calls. For example, a service like [jmp.chat](https://www.kicksecure.com/wiki/Mobile_Phone_Security#Phone_Number_Registration_Unlinked_to_SIM_Card) gives you a VoIP number, which you can optionally pay for in bitcoin, and you make calls using an XMPP (Jabber) client - [Cheogram](https://cheogram.com/) works well. 

Though usually more expensive than VoIP, a flip phone or landline also works well for making and receiving 'normal life' calls if you're not going to use it to talk to anarchists, and in the case of the flip phone, if you will leave it at home. These have the advantage that you don't need a computer to be turned on to hear it ring.

A flip phone can be used for any [two-factor authentication](/glossary/#two-factor-authentication-2fa) (2FA) you need (if a service requires you to receive a text message to log in), which does not always work with VoIP providers. If you only need a flip phone for 2FA, [online phone numbers](https://anonymousplanet.org/guide.html#online-phone-number) are another option. 

## Communication

Not having a phone requires a change in the way you socialize if you are [already caught in the net](https://theanarchistlibrary.org/library/return-fire-vol-4-supplement-caught-in-the-net). Being intentional about minimizing the mediation of screens in our relationships is a valuable goal in and of itself. 

Except in cases where it is unavoidable (as in the case of a publication whose editors live in different regions), organizing should not be mediated by technology. The dynamic by which, in some parts of the anarchist space, the entirety of how anarchists organize projects together has been reduced to a monoculture of Signal group chats (or worse) warrants much criticism. This capture of organizing relationships by smartphone culture has led to a meeting that never ends. It also means that our organizing is relatively easy to surveil. Only one phone in the group chat needs to be compromised with malware to access all the messages. 

That said, encrypted communication is useful for setting up real-life meetings where life and organizing actually take place, or for projects that are shared with comrades across distances. See [Encrypted Messaging for Anarchists](/posts/e2ee/) for various options appropriate to an anarchist [threat model](/glossary/#threat-model).  

## Emergency Calls 

A passerby on the street will often lend you their phone to make an urgent call. If the need arises in remote areas, such as on a hiking trip, the use of a flip phone would be a good solution. To receive emergency calls, if you cannot be reached from a computer as described above, we can stop by each other's houses or arrange encrypted messaging check-ins in advance. What scenarios actually require the ability to receive a call at any moment? If they actually exist in your life, you can organize around them without projecting that urgency into all areas and moments of your life.

## Directions

Buy a paper map of your area and bring it with you. For longer trips or trips where you need directions, use [OpenStreetMap](https://www.openstreetmap.org/) to note them ahead of time. Wear a watch to make sure you arrive on time.  

## Music and Podcasts 

They still make MP3 players! For a much lower price, you can play music and podcasts, but the device has no GPS or radio hardware. However, that doesn't mean you can't be geolocated by an MP3 player. If your Wi-Fi is turned on, your MP3 player's approximate location can be determined from its IP address.

# Appendix: Against the Smartphone

*From [Fernweh (#24)](https://fernweh.noblogs.org/texte/24-ausgabe/gegen-das-smartphone/)* 

It's always with us, always on, no matter where we are or what we're doing. It keeps us informed about everything and everyone: what our friends are doing, when the next subway leaves, and what the weather will be like tomorrow. It takes care of us, wakes us up in the morning, reminds us of important appointments, and always listens to us. It knows everything about us, when we go to bed, where we are and when, who we communicate with, who our best friends are, what music we listen to, and what our hobbies are. And all it asks for is a little electricity now and then? 

When I stroll through an area or take the subway, I see it with almost everyone, and no one can last more than a few seconds without frantically reaching for their pocket: the cell phone is whipped out, a message is sent, an email is checked, a photo is liked. It is put away again, a short break, and here we go again, skimming through today's news and checking out what all the friends are up to...

It's our companion when we're on the toilet, at work or at school, and it apparently helps to fight boredom while we're waiting or working, etc. Is this perhaps one of the reasons for the success of all these technological devices, that real life is so damn boring and monotonous that a few square centimeters of screen is almost always more exciting than the world and the people around us? Is it like an addiction (people definitely have withdrawal symptoms...) or has it even become part of our body? Without it, we no longer know how to orient ourselves and feel that something is missing? So it is no longer just a tool or a toy, but a part of us that also exerts a certain control over us, to which we adapt, for example, by not leaving the house until the battery is fully charged? Is thesmartphone the first step in blurring the line between human and robot? 

When we see what technocrats of all kinds are prophesying (Google Glasses, implanted chips, etc.), it almost seems as if we are heading towards becoming cyborgs, people with implanted smartphones that we control through our thoughts (until our thoughts themselves are finally controlled). It is not surprising that the media, the spokesmen of domination, show us only the positive aspects of this development, but it is shocking that almost no one questions this view. It's probably every ruler's wildest dream: to be able to monitor everyone's thoughts and actions at all times and to intervene immediately in case of any disturbance. Totally controlled and monitored worker bees who are allowed to have some (virtual) fun as a reward while a few profit. 

With the vast amounts of data now so readily available from anyone and everyone at any time of day, social control and surveillance has also reached a whole new level. This now goes far beyond tapping cell phones or sifting through messages (as during the 2011 UK riots). With access to an incredible amount of information, intelligence agencies are able to define what is "normal." They can determine which locations are "normal" for us, which contacts are "normal," etc. In short, they can quickly establish and almost in real time if people are deviating from their "normal" behavior. This gives some people enormous power, which is used whenever there is an opportunity to take advantage of that power (i.e. to surveil people). Technology is part of power, it comes from power and needs power. It takes a world in which people have extreme power to enable the production of something like the smartphone. All technology is a product of the current oppressive world, is part of it, and will reinforce it.

In today's world, nothing is neutral. To date, everything that has been or is being developed is designed to extend control and to make money. Many of the innovations of recent decades (such as GPS, nuclear power, or the internet) even come directly from the military. Most of the time these two aspects go hand in hand, but the "welfare of mankind" is certainly not a motivation, especially when it is developed by the military. 

Perhaps taking the example of architecture can better illustrate something as complex as technology: let's take an empty and disused prison, what should be done with this structure except to tear it down? Its very architecture, its walls, its watchtowers, its cells, already contain the purpose of this building: to imprison people and destroy them psychologically. It would be impossible for me to live there, simply because the building is oppressive. 

It is the same with all the technologies of today that are presented to us as progress and as something that makes life easier. They were designed with the intention of making money and controlling us, and will always carry that. No matter how many supposed benefits your smartphone brings you, those who get rich by collecting your data and monitoring you will always benefit more than you. 

If in the past it was said that "knowledge is power", today it should be said that "information is power". The more rulers know about their flocks, the better they can dominate them - in this sense, technology as a whole is a powerful tool of control to predict and thus prevent people from coming together to attack what oppresses them.

These smartphones seem to need a little more than just a little electricity... In our generation, which at least knew a world without smartphones, there might still be some people who understand what I'm talking about, who still know what it's like to have a discussion without looking at their phone every thirty seconds, to get lost and discover new places by doing so, or to debate something without immediately asking Google for the answer. But I don't want to go back to the past, even though it wouldn't be possible anyway, but the more technology penetrates our lives, the harder it becomes to destroy it. What if we are one of the last generations able to stop this evolution of human beings into completely controlled robots? 

And what if at some point we will be unable to reverse this development? Humanity has reached a historically new stage with technology. A stage where it is able to annihilate all human life (nuclear energy) or to modify it (genetic manipulation). This fact underlines once again the need to act today to destroy this society. To do this, we need to encounter other people and communicate our ideas. 

Isn't it obvious that if instead of talking to each other, we only communicate in messages of five sentences or less, there will be long-term effects? Apparently not. First of all, the way we think influences the way we speak, and vice versa - the way we speak and communicate influences the way we think. If we are only able to exchange the shortest and most concise messages, how can we talk about a completely different world? And if we can't even talk about another world, how can we reach for it?

Direct communication between autonomous individuals is the basis of any shared rebellion, it is the starting point of shared dreams and common struggles. Without unmediated communication, a struggle against this world and for freedom is impossible.

So let's get rid of the smartphones and meet face to face in an insurgency against this world! Let's become uncontrollable!

